
CREATE TABLE OTLT
(code_type  VARCHAR(32) NOT NULL,
 code_value VARCHAR(32) NOT NULL,
 code_description VARCHAR(64) NOT NULL,
  PRIMARY KEY (code_type, code_value));

INSERT INTO OTLT VALUES('pref_cd',   '01',   'kC');
INSERT INTO OTLT VALUES('pref_cd',   '02',   'X');
INSERT INTO OTLT VALUES('pref_cd',   '03',   'Hc');
INSERT INTO OTLT VALUES('pref_cd',   '47',   '');
INSERT INTO OTLT VALUES('client_cd', 'A001', 'A');
INSERT INTO OTLT VALUES('client_cd', 'B002', 'B');
INSERT INTO OTLT VALUES('client_cd', 'B027', 'Zw');
INSERT INTO OTLT VALUES('sex_cd',    '0',    's');
INSERT INTO OTLT VALUES('sex_cd',    '1',    'j');
INSERT INTO OTLT VALUES('sex_cd',    '2',    '');
INSERT INTO OTLT VALUES('sex_cd',    '9',    Kps\');


CREATE TABLE DataPop
(pref_cd  CHAR(2) NOT NULL PRIMARY KEY,
 population INTEGER NOT NULL);

INSERT INTO DataPop VALUES ('01', 1000);
INSERT INTO DataPop VALUES ('03', 2000);
INSERT INTO DataPop VALUES ('04', 1200);
INSERT INTO DataPop VALUES ('05', 5000);
INSERT INTO DataPop VALUES ('07', 8000);


SELECT MASTER.code_value AS pref_cd,
         MASTER.code_description AS pref_name,
       DATA.population AS pop
  FROM OTLT MASTER LEFT OUTER JOIN DataPop DATA
    ON MASTER.code_value = DATA.pref_cd
 WHERE MASTER.code_type  = 'pref_cd';


/* Ԕ͈͂OTLT */
CREATE TABLE OTLT
(code_type  VARCHAR(32) NOT NULL,
 code_value VARCHAR(32) NOT NULL,
 start_year INTEGER     NOT NULL,
 end_year   INTEGER     NOT NULL,
 code_description VARCHAR(64) NOT NULL,
  PRIMARY KEY (code_type, code_value, start_year));


INSERT INTO OTLT VALUES('age_class',	'01',	1998,	2000,	'0Έȏ15Ζ');
INSERT INTO OTLT VALUES('age_class',	'02',	1998,	2000,	'15Έȏ20Ζ');
INSERT INTO OTLT VALUES('age_class',	'03',	1998,	2000,	'20Έȏ30Ζ');
INSERT INTO OTLT VALUES('age_class',	'04',	1998,	2000,	'30Έȏ40Ζ');
INSERT INTO OTLT VALUES('age_class',	'05',	1998,	2000,	'40Έȏ50Ζ');
INSERT INTO OTLT VALUES('age_class',	'06',	1998,	2000,	'50Έȏ');
INSERT INTO OTLT VALUES('age_class',	'01',	2001,	2003,	'0Έȏ20Ζ');
INSERT INTO OTLT VALUES('age_class',	'02',	2001,	2003,	'20Έȏ40Ζ');
INSERT INTO OTLT VALUES('age_class',	'03',	2001,	2003,	'40Έȏ60Ζ');
INSERT INTO OTLT VALUES('age_class',	'04',	2001,	2003,	'60Έȏ80Ζ');
INSERT INTO OTLT VALUES('age_class',	'05',	2001,	2003,	'80Έȏ');
INSERT INTO OTLT VALUES('age_class',	'01',	2004,	9999,	'0Έȏ15Ζ');
INSERT INTO OTLT VALUES('age_class',	'02',	2004,	9999,	'15Έȏ30Ζ');
INSERT INTO OTLT VALUES('age_class',	'03',	2004,	9999,	'30Έȏ45Ζ');
INSERT INTO OTLT VALUES('age_class',	'04',	2004,	9999,	'45Έȏ60Ζ');
INSERT INTO OTLT VALUES('age_class',	'05',	2004,	9999,	'60Έȏ75Ζ');
INSERT INTO OTLT VALUES('age_class',	'06',	2004,	9999,	'75Έȏ');

/* 񎝂e[u */
CREATE TABLE AccountsCols
(act_nbr  CHAR(6) NOT NULL,
 amt_2006 INTEGER ,
 amt_2007 INTEGER ,
 amt_2008 INTEGER ,
  PRIMARY KEY (act_nbr));


INSERT INTO AccountsCols VALUES('007634',	320000, 490000,	120000);
INSERT INTO AccountsCols VALUES('135981',	88000, 	90000, 	100000);
INSERT INTO AccountsCols VALUES('447900',	2348900,NULL, 	9000);
INSERT INTO AccountsCols VALUES('238901',	NULL,	5000,	NULL);



/* SĂ̔NxɂāAc100,000~ȏ̌I
   F񎝂̏ꍇ */
SELECT act_nbr
  FROM AccountsCols
 WHERE amt_2006 >= 100000
   AND amt_2007 >= 100000
   AND amt_2008 >= 100000;

CREATE TABLE AccountsRows
(act_nbr  CHAR(6) NOT NULL,
 year INTEGER NOT NULL,
 amt  INTEGER NOT NULL,
  PRIMARY KEY (act_nbr, year));

INSERT INTO AccountsRows VALUES('007634',	2006,	320000); 
INSERT INTO AccountsRows VALUES('007634',	2007,	490000); 
INSERT INTO AccountsRows VALUES('007634',	2008,	120000); 
INSERT INTO AccountsRows VALUES('135981',	2006,	88000); 
INSERT INTO AccountsRows VALUES('135981',	2007,	90000); 
INSERT INTO AccountsRows VALUES('135981',	2008,	100000); 
INSERT INTO AccountsRows VALUES('447900',	2006,	2348900); 
INSERT INTO AccountsRows VALUES('447900',	2008,	9000); 
INSERT INTO AccountsRows VALUES('238901',	2007,	5000); 



/* SĂ̔NxɂāAc100,000~ȏ̌IFs̏ꍇ */
SELECT act_nbr
  FROM AccountsRows
 GROUP BY act_nbr
HAVING COUNT(*) = SUM(CASE WHEN amt >= 100000 
                        THEN 1
                        ELSE 0 END);

/* WvL[Ȃ */
CREATE TABLE Items
(item_no    CHAR(3) NOT NULL,
 item_name  VARCHAR(64) NOT NULL,
 price      INTEGER NOT NULL,
  PRIMARY KEY (item_no));


INSERT INTO Items VALUES ('001',	'',			400 );
INSERT INTO Items VALUES ('002',	'p',			200 );
INSERT INTO Items VALUES ('003',	'{[y',	100 );
INSERT INTO Items VALUES ('004',	'',		300 );
INSERT INTO Items VALUES ('005',	'NbL[',		550 );
INSERT INTO Items VALUES ('006',	'r[',		280 );
INSERT INTO Items VALUES ('007',	'͂',		350 );
INSERT INTO Items VALUES ('008',	'Rbv',		600 );
INSERT INTO Items VALUES ('009',	'',			320 );


/* WvL[ǉ */
ALTER TABLE Items ADD item_grp CHAR(1);


/* WvL[̍XV */
UPDATE Items
   SET item_grp = CASE WHEN item_no IN ('001', '004', '008', '009') THEN 'A'
                       WHEN item_no IN ('002', '005', '006') THEN 'B'
                       WHEN item_no IN ('003', '007') THEN 'C'
                       ELSE NULL END;

/* XVWvL[gWv */
SELECT item_grp,
       AVG(price) AS avg_price
  FROM Items
 GROUP BY item_grp;


/* ĝăL[gWv */
SELECT CASE WHEN item_no IN ('001', '004', '008', '009')
              THEN 'A'
            WHEN item_no IN ('002', '005', '006')
              THEN 'B'
            WHEN item_no IN ('003', '007')
              THEN 'C'
            ELSE NULL END AS item_grp,
       AVG(price) AS avg_price
  FROM Items
 GROUP BY CASE WHEN item_no IN ('001', '004', '008', '009')
                 THEN 'A'
               WHEN item_no IN ('002', '005', '006')
                 THEN 'B'
               WHEN item_no IN ('003', '007')
                 THEN 'C'
               ELSE NULL END;



